package io.reisub.dreambot.util.ui;

import java.util.HashMap;
import java.util.Map;

public class Option implements Cloneable {
    private final String name, info;
    private final Map<String, String> parameters;

    private String customName = "";

    public Option(String name) {
        this(name, "");
    }

    public Option(String name, String info) {
        this.name = name;
        this.info = info;
        parameters = new HashMap<>();
    }

    public String getName() {
        return name;
    }

    @Override
    public String toString() {
        if (!customName.equals("")) {
            return customName;
        }

        if (info.equals("")) {
            return name;
        } else {
            return name + " (" + info + ")";
        }
    }

    public void setCustomName(String customName) {
        this.customName = customName;
    }

    public void setParameter(String key, String value) {
        parameters.put(key, value);
    }

    @Override
    public Option clone() {
        try {
            return (Option) super.clone();
        } catch (CloneNotSupportedException e) {
            throw new AssertionError();
        }
    }
}
